﻿#!/bin/bash

# ShAirPort for Raspbian 一键安装包
# By Bill Haofei Gong on 15th Jan, 2013
#
# 感谢所有此脚本中所有引用的开源代码的作者。You guys rock!
# 同时感谢 http://trouch.com/2012/08/03/airpi-airplay-audio-with-raspberry 的作者，以及指出 iOS 6 兼容性解决方案的评论者 Chris

# 升级并清理 Raspbian
sudo apt-get update && sudo apt-get dist-upgrade -y
sudo apt-get autoremove -y && sudo apt-get autoclean && sudo apt-get clean

# 设置音频输出为耳机插孔，取消静音并将音量调至最大
sudo amixer cset numid=3 1
amixer sset Master unmute
amixer sset Master 100%

# 安装依赖包
sudo apt-get install git libao-dev libssl-dev libcrypt-openssl-rsa-perl libio-socket-inet6-perl libwww-perl avahi-utils libmodule-build-perl -y

# 从Git克隆源码
git clone git://github.com/njh/perl-net-sdp.git perl-net-sdp
git clone git://github.com/hendrikw82/shairport.git shairport

# 编译并安装依赖的组件
cd perl-net-sdp/
perl Build.PL
./Build
./Build test
sudo ./Build install
cd ..

# 编译ShAirPort，测试运行并安装
cd shairport/
make
echo "现在，测试运行将要开始！"
echo "请将你的AirPlay设备连接到Raspberry Pi所在的同一网络中，然后查看AirPlay列表中是否存在一个名为\"TestPort\"的服务器。连接到这个服务器并随便播放一个音频文件测试功能是否正常。别忘了将你的音响插到Raspberry Pi的耳机孔上。"
echo "在试运行成功后，请按下 \"Ctrl+C\" 来继续安装。"
./shairport.pl -a TestPort
sudo make install
sudo cp shairport.init.sample /etc/init.d/shairport
sudo sed -i 's/DAEMON_ARGS=\"-w \$PIDFILE\"/DAEMON_ARGS=\"-w \$PIDFILE -a AirPlay-RPi\"/g' /etc/init.d/shairport
sudo update-rc.d shairport defaults
sudo service shairport start

# 安装完毕
echo "###############################################"
echo "# 安装结束！                                  #"
echo "# 现在你应该可以上找到一个名为\"AirPlay-RPi\"的 #"
echo "# AirPlay服务器，将设备连接到这个服务器上即可 #"
echo "# 通过Raspberry Pi播放音乐了！                #"
echo "# 建议你运行\"sudo shutdown -rf now\"重启RPi    #"
echo "###############################################"